%% Generated by lilypond-book
%% Options: [exampleindent=10.16\mm,indent=0\mm,line-width=160\mm]
\include "lilypond-book-preamble.ly"


% ****************************************************************
% Start cut-&-pastable-section
% ****************************************************************

#(ly:set-option 'eps-box-padding 3.000000)



\paper {
  indent = 0\mm
  line-width = 160\mm
  % offset the left padding, also add 1mm as lilypond creates cropped
  % images with a little space on the right
  line-width = #(- line-width (* mm  3.000000) (* mm 1))
}

\layout {
  
}




% ****************************************************************
% ly snippet:
% ****************************************************************
\sourcefilename "snippets/numbering-groups-of-measures.ly"
\sourcefileline 0
%% DO NOT EDIT this file manually; it was automatically
%% generated from the LilyPond Snippet Repository
%% (http://lsr.di.unimi.it).
%%
%% Make any changes in the LSR itself, or in
%% `Documentation/snippets/new/`, then run
%% `scripts/auxiliar/makelsr.pl`.
%%
%% This file is in the public domain.

\version "2.23.13"

\header {
%% Translation of GIT committish: a8a85e19654e46d725563e6deba44083ef137a2c
  texidocja = "
このスニペットは @code{Measure_counter_engraver} で、@c
連続した小節をいくつかにグループ分けし、それぞれに番号を表示する@c
方法を示しています。@c
どのような範囲を取っても良く、繰り返しが含まれていてもかまいません。

エングラーバは適切なコンテキストに追加する必要があります。今回は
@code{Staff} コンテキストを使用しています。他の選択肢としては
@code{Dynamics} コンテキストがあります。

カウンタは @code{\\startMeasureCount} で始まり、@code{\\stopMeasureCount}
で終わります。番号はデフォルトで @code{1} から開始しますが、@code{count-from}
プロパティをオーバライドすることで変更することができます。

小節の途中で改行される場合、小節番号は 2 回表示されます。@c
改行後の数字は括弧付きで表示されます。
"
  doctitleja = "小節のグループに番号付けする"

%% Translation of GIT committish: a3fd5364fc4f247579da0ed2bfea887ab37285c6
  texidocfr = "
Cet extrait illustre l'utilisation du @code{Measure_counter_engraver}
aux fins de numéroter un groupe de mesures successives. La section à
numéroter peut éventuellement comporter des reprises.

Le graveur doit être ajouté au contexte approprié. Il est ici attaché au
contexte @code{Staff}, mais pourrait l'être à un contexte
@code{Dynamics}.

Le compteur est lancé par @code{\\startMeasureCount} et arrêté par
@code{\\stopMeasureCount}. La numérotation commence à @code{1} par
défaut, comportement qui peut se modifier à l'aide de la propriété
@code{count-from}.

Lorsqu'une mesure s'étend après un saut de ligne, le numéro y est alors
répété, entre parenthèses.
"

  doctitlefr = "Numérotation de groupes de mesures"

%% Translation of GIT committish: 262abf17c7827e88e3d509100c43920c8e225bec
  texidoces = "
Este fragmento de código muestra el uso del grabador
@code{Measure_counter_engraver} para numerar grupos de compases
sucesivos.  Se puede numerar cualquier período de compases tanto si
tiene repeticiones como si no.

Se debe añadir el grabador al contexto adecuado.  Aquí se usa un
contexto @code{Staff}; otra posibilidad sería un contexto
@code{Dynamics}.

El contador se inicia con @code{\\startMeasureCount} y finaliza con
@code{\\stopMeasureCount}.  La numeración comienza con @code{1}, de
forma predeterminada, pero se puede modificar este comportamiento
sobreescribiendo la propiedad @code{count-from}.

Cuando un compás se extiende más allá de un salto de línea, el número
aparece dos veces, la segunda vez entre paréntesis.

"
  doctitlees = "Numerar grupos de compases"

%% Translation of GIT committish: 262abf17c7827e88e3d509100c43920c8e225bec
  texidocca = "
Aquest fragment de codi mostra l'ús del gravador
@code{Measure_counter_engraver} per numerar grups de compassos
  successius.  Es pot numerar qualsevol període de compassos tant
  si té repeticions com si no.

S'ha d'afegir el gravador al context adequat.  Aquí s'usa un
context @code{Staff}; una altra possibilitat seria un context
@code{Dynamics}.

El comptador s'inicia amb @code{\\startMeasureCount} i finalitza amb
@code{\\stopMeasureCount}.  La numeració comença amb @code{1}, de
forma predeterminada, però es pot modificar aquest comportament
sobreescrivint la propietat @code{count-from}.

Quan un compàs s'estén més enllà d'un salt de línia, el número
apareix dues vegades, la segona vegada entre parèntesi.

"
  doctitleca = "Numerar grups de compassos"

  lsrtags = "contexts-and-engravers, editorial-annotations, repeats, staff-notation"

  texidoc = "
This snippet demonstrates the use of the
@code{Measure_counter_engraver} to number groups of successive
measures.  Any stretch of measures may be numbered, whether consisting
of repetitions or not.

The engraver must be added to the appropriate context.  Here, a
@code{Staff} context is used; another possibility is a @code{Dynamics}
context.

The counter is begun with @code{\\startMeasureCount} and ended with
@code{\\stopMeasureCount}.  Numbering will start by default with
@code{1}, but this behavior may be modified by overriding the
@code{count-from} property.

When a measure extends across a line break, the number will appear
twice, the second time in parentheses.
"

  doctitle = "Numbering groups of measures"
} % begin verbatim


\layout {
  \context {
    \Staff
    \consists #Measure_counter_engraver
  }
}

\new Staff {
  \startMeasureCount
  \repeat unfold 7 {
    c'4 d' e' f'
  }
  \stopMeasureCount
  \bar "||"
  g'4 f' e' d'
  \override Staff.MeasureCounter.count-from = #2
  \startMeasureCount
  \repeat unfold 5 {
    g'4 f' e' d'
  }
  g'4 f'
  \bar ""
  \break
  e'4 d'
  \repeat unfold 7 {
    g'4 f' e' d'
  }
  \stopMeasureCount
}



% ****************************************************************
% end ly snippet
% ****************************************************************
